/*
 * 
 * 
 */

package autofeature.intermediate;


import autofeature.ParserBug;
import autofeature.parser.RuleMatch;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import org.antlr.runtime.tree.CommonTree;
import org.antlr.runtime.tree.Tree;

import static autofeature.intermediate.TreeUtil.*;

/**
 *
 * @author Hendrik Speidel - speidel@fmi.uni-passau.de
 */
public class Specification {

    private AST ast;
    private List<Automaton> automatons;

    public Specification(AST ast) {
        this.ast = ast;
    }

    public String getIntroduction() {
        if (ast.root.getChildCount() > 0) {
            CommonTree first = (CommonTree) ast.root.getChild(0);
            if (first.getText().equals("dummy")) {
                RuleMatch rule = ast.ruleMatches.get(first);
                if (rule == null) {
                    throw new ParserBug("There is an 'intro' node in the AST, but no rule referenced!");
                }
                return rule.toString();
                //String intro = ast.blocks.get(first);
                //if (intro == null) {
                //    throw new ParserBug("There is an 'intro' node in the AST, but no block referenced!");
                //}
                //return intro;
            }
        }
        return "";
    }


    public List<Automaton> getAutomata() {
        if (automatons == null) {
            automatons = new ArrayList<Automaton>();

            for (CommonTree child: childs(ast.root)) {

                if (child.getText().equals("automaton")) {
                    automatons.add(new Automaton(ast.asAst(child)));
                }

            }    
        }       
        return automatons;
    }

}
