dummy {
    typedef struct {int i;} NODE;
}

#include "Email.h"
#include "Client.h"
#include "slist.h"

automaton EncryptConsistently4 {

    introduction {
        struct email_security {
            int msgid;
            int sensitive;        
        };
        
        int find_email_security(void *listdata, void *searchdata) {
          return ((struct email_security *) listdata)->msgid == *((int*) searchdata);
        }

        NODE* observed_email = 0;

        int get_email_security(int msgid) {
            NODE* found = list_find(observed_email, find_email_security, &msgid);

            if (!found) {
                return -1;
            }
            return ((struct email_security *) found->data)->sensitive;
        }

        void set_email_security(int msgid, int sensitive) {
            //never changes ... no need to search ... just create
            struct email_security* es;
            es = (struct email_security*) malloc(sizeof(struct email_security));
            es->msgid = msgid;
            es->sensitive = sensitive;
            observed_email = list_insert_beginning(observed_email, es);
        }

    }

    

    before void mail(_:struct client*, msg:struct email*) {

        printf("before mail\n");
        
        int status = get_email_security(msg->id);        
        
        printf("privacy status: %d\n", status);

        if (status == -1) {
            set_email_security(msg->id, isEncrypted(msg));
        } else if (status != isEncrypted(msg)) {
            fail;
        }

    }

}
