
struct JoinPoint { 
	void** (*fp) (struct JoinPoint *);
	void ** args;
	int argsCount;
	const char ** argsType;
	 void * (*arg)(int, struct JoinPoint *); 
	 const char * (*argType)(int , struct JoinPoint *); 
	void ** retValue;
	const char * retType;
	const char * funcName ;
	const char * targetName ;
	const char * fileName ;
	const char * kind ;
	void * excep_return ;
};

 struct __UTAC__EXCEPTION {
	void * jumpbuf ;
	unsigned long long int prtValue ;
	int pops;
	struct __UTAC__CFLOW_FUNC {
		int (*func)(int,int) ;
		int val ;
		struct __UTAC__CFLOW_FUNC * next; 
	} * cflowfuncs; 
}; 

extern void __utac__exception__cf_handler_set(void * exception, int (*cflow_func)(int, int), int val) ; 
extern void __utac__exception__cf_handler_free(void * exception);
extern void __utac__exception__cf_handler_reset(void * exception) ; 
extern void * __utac__error_stack_mgt(void * env , int mode, int count) ;

# 1 "build/List_spec.c" 
# 1 "<built-in>" 
# 1 "<command line>" 
# 1 "build/List_spec.c" 
# 13 "./Email.h" 1
struct email {int id; char *from; char *to; char *subject; char *body; int isEncrypted; char *encryptionKey; 
}; 
#line 16 "./Email.h"
struct email *cloneEmail(struct email *msg); 
#line 19 "./Email.h"
void printMail(struct email *msg); 
#line 22 "./Email.h"
int isReadable(struct email *msg); 
#line 25 "./Email.h"
int isEncrypted(struct email *msg); 
# 4 "build/List_spec.c" 2
# 1 "./Client.h" 1
# 1 "./Email.h" 1
# 7 "./Client.h" 2
# 10 "./slist.h" 1
typedef struct node_s {void *data; struct node_s *next; 
}NODE; 
#line 14 "./slist.h"
 NODE *list_create(void *data); 
#line 17 "./slist.h"
 NODE *list_insert_after( NODE *node, void *data); 
#line 20 "./slist.h"
 NODE *list_insert_beginning( NODE *list, void *data); 
#line 23 "./slist.h"
int list_remove( NODE *list,  NODE *node); 
#line 26 "./slist.h"
int list_foreach( NODE *node, int (*func)(void *)); 
#line 29 "./slist.h"
 NODE *list_find( NODE *node, int (*func)(void *, void *), void *data); 
#line 14 "./Client.h"
struct client {char *name;  NODE *outgoingBuffer;  NODE *userPublicKeyPairs; char *privateKey;  NODE *addressBook; int idCounter; 
}; 
#line 17 "./Client.h"
void outgoing(struct client *client, struct email *msg); 
#line 20 "./Client.h"
void incoming(struct client *client, struct email *msg); 
#line 23 "./Client.h"
struct userPublicKeyPair {char *user; char *publicKey; 
}; 
#line 26 "./Client.h"
int isKeyPairValid(char *publicKey, char *privateKey); 
#line 28 "./Client.h"
void encrypt(struct client *client, struct email *msg); 
#line 31 "./Client.h"
struct addressBookEntry {char *alias;  NODE *address; 
}; 
#line 35 "./Client.h"
void resolveAlias(struct client *client, struct email *msg); 
#line 37 "./Client.h"
void decrypt(struct client *client, struct email *msg); 
#line 40 "./Client.h"
void addMessageID(struct client *client, struct email *msg); 
# 8 "./Client.h" 2
# 5 "build/List_spec.c" 2
# 1 "./slist.h" 1
# 11 "build/List_spec.c" 2
struct email_security {int msgid; int sensitive; 
}; 
#line 13 "build/List_spec.c"
int find_email_security(void *listdata, void *searchdata)  {

#line 14 "build/List_spec.c"
return ((((struct email_security *)listdata))->msgid) == (*(((int *)searchdata))); }
 
#line 17 "build/List_spec.c"
 NODE *observed_email = 0; 
#line 19 "build/List_spec.c"
int get_email_security(int msgid)  {

#line 20 "build/List_spec.c"

#line 20 "build/List_spec.c"
 NODE *found = list_find(observed_email, find_email_security, (&msgid));
#line 22 "build/List_spec.c"
if ((!found)){
{ 
#line 23 "build/List_spec.c"
return (-1); } }
#line 25 "build/List_spec.c"
return ((((struct email_security *)(found->data)))->sensitive); }
 
#line 28 "build/List_spec.c"
void set_email_security(int msgid, int sensitive)  {

#line 30 "build/List_spec.c"

#line 30 "build/List_spec.c"
struct email_security *es;
#line 31 "build/List_spec.c"
es = ((struct email_security *)malloc(sizeof (struct email_security ))); 
#line 32 "build/List_spec.c"
(es->msgid) = msgid; 
#line 33 "build/List_spec.c"
(es->sensitive) = sensitive; 
#line 34 "build/List_spec.c"
observed_email = list_insert_beginning(observed_email, es); }
 
#line 39 "build/List_spec.c"
 inline void __utac_acc__List_spec__1(struct email *msg) {



#line 42 "build/List_spec.c"
printf("before mail\n"); 
#line 44 "build/List_spec.c"

#line 44 "build/List_spec.c"
int status = get_email_security((msg->id));
#line 46 "build/List_spec.c"
printf("privacy status: %d\n", status); 
#line 48 "build/List_spec.c"
if (status == (-1)){
{ 
#line 49 "build/List_spec.c"
set_email_security((msg->id), isEncrypted(msg)); } }else{
if (status != isEncrypted(msg)){
{ 
#line 51 "build/List_spec.c"
printf("ERROR!! Safety property violated!!\n"); } }}}

 



