/*
 * 
 * 
 */

package cpawsl.parser;

import autofeature.parser.SpecificationReader;
import java.io.File;
import java.io.FileFilter;
import java.util.Arrays;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Hendrik Speidel - speidel@fmi.uni-passau.de
 */
public class CGrammarTest {

    Logger logger = Logger.getLogger(CGrammarTest.class.getName());

    String TEST_DIR = "/export/home/henne/uni/cpawsl/test/";


    @Test
    public void testC() {
        System.out.println("C Parser Tests");
        System.out.println("=============================");
        System.out.println("");

        File cTestDir = new File(TEST_DIR + "cpawsl/parser/c-tests/");

        File[] tests = cTestDir.listFiles(new FileFilter() {

            public boolean accept(File pathname) {
                return pathname.getAbsolutePath().endsWith(".spec");
            }
        });

        Arrays.sort(tests);

        SpecificationReader reader = new SpecificationReader();

        boolean fail = false;

        for (File test : tests) {
            
            System.out.println("- testing: " + test.getName());


            boolean expectedFail = test.getName().endsWith("__illegal.spec");

            if (expectedFail) {
                System.out.println("FAILURE EXPECTED: ");
            }

            System.out.flush();

            try {
                reader.readFile(test.getAbsolutePath());

            } catch (Exception ex) {                
                fail = true;

            }

            if (expectedFail && !fail) {
                System.out.println("no exception.");
            }

            if (expectedFail != fail) {
                logger.log(Level.SEVERE, "SUBTEST FAILED: " + test.getName());
            }
            assertTrue(expectedFail == fail);
            System.err.flush();
            //sleep because flushing System.err is not enough ... messages still mix up
            //most likely related to logger
            try {
                Thread.sleep(300);
            } catch (InterruptedException ex) {
                //ignore
            }
        }

        

    }

}